# Dagger

Dagger is a platform for deploying your code using code.

Using Dagger, software teams can create custom deployment routes for their application, tailor-made for their infrastructure and workflow, in just a few lines of code.

For example, an application may have a production route, a staging route for QA and product reviews, and on-demand development routes for testing new features.

Dagger can create routes dynamically, which makes it a great fit for custom scripting and CI integration. Ever wanted to stand up a production-like deployment of your entire app for each pull request? Run integration tests across the development branches of multiple microservice repositories? See what your code will look like in production *before* opening a PR? Dagger provides a reliable foundation for automating these workflows, and many more.

Every Dagger route exposes the same standardized interface, designed for maximum developer productivity. Do you wish you could get the ease of use of Heroku without its limitations? With Dagger, each deployment route is like a miniature Heroku custom-built around your stack, instead of the other way around.

## Alpha disclaimer

Dagger is *alpha-quality software*. It has many bugs, the user interface is minimal, and it may change in incompatible ways at any time. If you are still willing to try it, thank you! We appreciate your help and encourage you to ask questions and report issues.

## Examples


## Learn More

* [Dagger vs. Other Software](doc/vs.md)
* [Installing Dagger](doc/install.md)
* [Tutorials](doc/tutorials.md)
* [Adding Dagger to your project](doc/adding_dagger.md)
* [Dagger Programmer Manual](doc/programmer.md)
* [Dagger Operator Manual](doc/operator.md)
